using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using C1.Win.C1FlexGrid;

namespace Subtotals
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private C1FlexGrid _flex;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this._flex = new C1.Win.C1FlexGrid.C1FlexGrid();
            ((System.ComponentModel.ISupportInitialize)(this._flex)).BeginInit();
            this.SuspendLayout();
            // 
            // _flex
            // 
            this._flex.ColumnInfo = "10,1,0,0,0,75,Columns:";
            this._flex.Dock = System.Windows.Forms.DockStyle.Fill;
            this._flex.Location = new System.Drawing.Point(0, 0);
            this._flex.Name = "_flex";
            this._flex.Size = new System.Drawing.Size(552, 317);
            this._flex.StyleInfo = resources.GetString("_flex.StyleInfo");
            this._flex.TabIndex = 0;
            this._flex.UseCompatibleTextRendering = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(552, 317);
            this.Controls.Add(this._flex);
            this.Name = "Form1";
            this.Text = "C1FlexGrid: Subtotals";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this._flex)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
            // populate grid
            Random rnd = new Random();
            _flex.Rows.Count = 15;
            _flex.Rows.Fixed = 2;
            //_flex[0,1] = "Direction";
            _flex[0, 2] = _flex[1, 2] = "Region";
            CellRange rg = _flex.GetCellRange(0, 3, 1, _flex.Cols.Count - 1);
            rg.Data = "Rnd";
            _flex.AllowMergingFixed = AllowMergingEnum.Free;
            foreach (Column col in _flex.Cols)
                col.AllowMerging = true;

            for (int r = _flex.Rows.Fixed; r < _flex.Rows.Count; r++)
            {
                _flex[r, 0] = r;
                _flex[r, 1] = (r < 7) ? "Inbound" : "Outbound";
                _flex[r, 2] = (r < 3) ? "North" : (r < 7) ? "South" : (r < 10) ? "East" : "West";
                for (int c = 3; c < _flex.Cols.Count; c++)
                {
                    _flex[r, c] = rnd.Next(1000);
                    _flex.Cols[c].Format = "#,###";
                }
            }

            // set up styles
            CellStyle s = _flex.Styles[CellStyleEnum.Subtotal0];
            s.BackColor = Color.Black;
            s.ForeColor = Color.White;
            s.Font = new Font(_flex.Font, FontStyle.Bold);
            s = _flex.Styles[CellStyleEnum.Subtotal1];
            s.BackColor = Color.DarkBlue;
            s.ForeColor = Color.White;
            s = _flex.Styles[CellStyleEnum.Subtotal2];
            s.BackColor = Color.DarkRed;
            s.ForeColor = Color.White;

            // more setup
            _flex.AllowDragging = AllowDraggingEnum.None;
            _flex.AllowEditing = false;
            _flex.Cols[0].WidthDisplay /= 3;
            _flex.Tree.Column = 1;

            // show totals
            UpdateTotals();

            _flex.Tree.Style = TreeStyleFlags.CompleteLeaf;		
		}
		private void UpdateTotals()
		{
			// clear existing totals
			_flex.Subtotal(AggregateEnum.Clear);

			// calculate subtotals (three levels, totals on every column)
			for (int c = 3; c < _flex.Cols.Count; c++)
			{
					_flex.Subtotal(AggregateEnum.Sum, 0, -1, c, "Grand Total");
					_flex.Subtotal(AggregateEnum.Sum, 1, 1, c, "Total for {0}");
					_flex.Subtotal(AggregateEnum.Sum, 2, 2, c, "Total for {0}");
			}

			// done, autosize columns to finish
			_flex.AutoSizeCols();
		}
	}
}
